Subject: Re: [alpine-user] AlpineLinux on Banana Pi?

From: Steffen Nurpmeso <[email-masked]>
Date: Wed, 18 Apr 2018 21:12:47 +0200

Hello Jean-Louis,

first a thank you! for responding!

Jean-Louis Fuchs <[email-masked]> wrote:
 |On Tue, Apr 10, 2018 at 08:57:23PM +0200, Steffen Nurpmeso wrote:
 |
 |> Thus my question: does anyone have experience with Banana Pi, does
 |> it work with AlpineLinux?  Will patches to enable zstd also there
 |
 |Well even the state of the linux-rpi is not too good. It has deviated from
 |the official raspi-kernel too much.

That is good to know, thanks.  In the meanwhile i have indeed
postponed my desire to buy something new a little bit, but maybe
then even aarch64 or so.  Then again, maybe not.  The Banana Pi
Kit[1] (it is M3 not what i said) ships with a Rasbpian Jessie
card, so i could start with that, then.  Pretty cool: Octocore,
2GB, SATA (via USB i think 2, max. 2 TB), Gigabit (via USB i think
2), 8 GB EMMC on board.  Maximum of 4 Watt.  Unbelievable!

  [1] https://www.conrad.de/de/banana-pi-2-gb-inkl-gehaeuse-inkl-netzteil-inkl-software-m3-starter-set-1435696.html

 |https://github.com/raspberrypi/linux
 |
 |1. Not being up to date
 |2. Not being close enough to defconfig
 |
 |make bcmrpi_defconfig (for raspi 1 and 0)
 |make bcm2709_defconfig (for raspi 2)
 |make bcmrpi3_defconfig (64bit for raspi 3, aarch64)
 |
 |https://bugs.alpinelinux.org/issues/6370
 |
 |I recently decided to try again to build a kernel for the raspi that is
 |more close. You can cross compile on alpine using
 |aports/scripts/bootstrap.sh $ARCH

Yeah i have seen Wilcox's message and kept it: great work!
I have not yet used it though, no time.  And my current machine
cannot do that in a reasonable time, too.

 |You can also use https://github.com/multiarch/qemu-user-static to test
 |packages, which is not relevant to the kernel, but interesting if you
 |need to compile user-space programs.
 |
 |If you build a kernel for yourself using abuild its quite fast, you
 |can be sloppy here and there. If you plan to submit the kernel to
 |alpine its going to be a lot of work (see aports/linux-vanilla) and
 |issue 6370.
 |
 |> Will patches to enable zstd also there be accepted?  
 |
 |If the Banana Pi hardware is so badly upstreamed like Raspberry Pi you
 |have to create linux-bpi. If it is close enough to Raspberry Pi and I
 |ever submit my Raspi-Kernel to Alpine, patches are probably ok.

Well, i do not know.  I think i will stick with the included
Raspbian and can then look around a bit, what is the firmware,
what are the drivers, etc.  I was just wondering why the zstd
archiver has the arm platform disabled...
And at the very first -- i just did not know ARM is not really
a first class citizen of and for Alpine.

 |> What about a browser.  Etc. etc. :-))
 |> What do you say?  Anyone?
 |
 |I had no problems browsing with the raspi because of memory [1], the
 |problem was that linux-rpi does not support OpenGL and it was not
 |smooth. Again see issue 6370.

Well, you know -- i often browse in a VM driving Alpine/chromium
via forwarded X, like this:

  ?0[steffen@devon shared]$ sh ~/browse.sh 
  web@localhost's password: 
  libGL error: unable to load driver: swrast_dri.so
  libGL error: failed to load driver: swrast
  [31111:31125:0418/210332.806569:ERROR:bus.cc(394)] Failed to connect to the bus: Failed to connect to socket /var/run/dbus/system_bus_socket: No such file or directory
  [31111:31156:0418/210333.344528:ERROR:bus.cc(394)] Failed to connect to the bus: Could not parse server address: Unknown address type (examples of valid types are "tcp" and on UNIX "unix")

(i have disabled IPv6)

  libGL error: unable to load driver: swrast_dri.so
  libGL error: failed to load driver: swrast
  [31170:31170:0418/210339.109737:ERROR:gl_implementation.cc(292)] Failed to load /usr/lib/chromium/swiftshader/libGLESv2.so: Error loading shared library /usr/lib/chromium/swiftshader/libGLESv2.so: No such file or directory
  [31111:31111:0418/210339.154869:ERROR:gpu_process_transport_factory.cc(1009)] Lost UI shared context.
  [31170:31170:0418/210339.165983:ERROR:viz_main_impl.cc(196)] Exiting GPU process due to errors during initialization
  [31193:31193:0418/210339.917339:ERROR:gl_implementation.cc(292)] Failed to load /usr/lib/chromium/swiftshader/libGLESv2.so: Error loading shared library /usr/lib/chromium/swiftshader/libGLESv2.so: No such file or directory
  [31193:31193:0418/210339.975879:ERROR:viz_main_impl.cc(196)] Exiting GPU process due to errors during initialization
  [31202:31202:0418/210340.866726:ERROR:gl_implementation.cc(292)] Failed to load /usr/lib/chromium/swiftshader/libGLESv2.so: Error loading shared library /usr/lib/chromium/swiftshader/libGLESv2.so: No such file or directory
  [31202:31202:0418/210340.935330:ERROR:viz_main_impl.cc(196)] Exiting GPU process due to errors during initialization
  [31212:31212:0418/210342.065079:ERROR:gl_implementation.cc(292)] Failed to load /usr/lib/chromium/swiftshader/libGLESv2.so: Error loading shared library /usr/lib/chromium/swiftshader/libGLESv2.so: No such file or directory
  [31212:31212:0418/210342.182335:ERROR:viz_main_impl.cc(196)] Exiting GPU process due to errors during initialization
  [31111:31146:0418/210343.657235:ERROR:socket_posix.cc(91)] CreatePlatformSocket() returned an error, errno=97: Address family not supported by protocol (97)
  ...

It smoothly drives me grazy.. and overcommits several processes to
one and a half gigabytes (for the initial blank page).

 |[1] 32-bit and musl-libc save a lot of memory.

Hmm, musl indeed induces quite some overhead that comes into play
when the number of objects increases (which i would expect in
a browser that does DOM, with CSS, Javascript etc.).  The more
objects, the lesser memory my own cache requires in comparison
(going into the megabytes for hundreds of thousands objects on
64-bit; bah! that i have to mention that).   But sure, 32-bit will
surely save a lot of memory, i have not used it natively (and for
browsing) since 2009.  

Thanks for responding.  I have never played around but i think
i will really dare to buy that kit if it is still available in
summer, in the July break.
Ciao!

--steffen
|
|Der Kragenbaer,                The moon bear,
|der holt sich munter           he cheerfully and one by one
|einen nach dem anderen runter  wa.ks himself off
|(By Robert Gernhardt)

---
Unsubscribe:  [email-masked]
Help:         [email-masked]
---